House Robber

题目描述:

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

这明显是个动态规划问题,直接上代码。

int rob(vector<int>& nums) {
    int n = nums.size();
    if (n == 0)
        return 0;
    if (n == 1)
        return nums[0];
    if (n == 2)
        return max(nums[0], nums[1]);
    
    vector<int> dp(n+1, 0);
    dp[1] = nums[0];

    for (int i = 2; i <= n; ++i)
    {
        dp[i] = max(nums[i-1] + dp[i-2], dp[i-1]);
    }
    return dp[n];
}

    由于声明了一个数组,所以空间复杂度为O(n)。当然,我们可以把空间复杂度降到O(1),因为每次我们只需要数组最新的两个元素。不过,这道题还有一种解题思路:对于每个房子,我们有两个选择,抢或不抢。如果抢了,说明前面的房子我们没抢;如果没抢,说明前面的房子我们可能抢了也可能没抢,此时选择两种情况下钱多的那种情况。

int rob(vector<int>& nums) {
    int n = nums.size();
    if (n == 0)
        return 0;
    if (n == 1)
        return nums[0];
    if (n == 2)
        return max(nums[0], nums[1]);

    int a = nums[0];    // rob current
    int b = 0;          // not rob current
    for (int i = 1; i < n; ++i)
    {
        int tmp = max(a, b);
        a = b + nums[i];
        b = tmp;
    }
    return max(a, b);
}

可参见 https://leetcode.com/discuss/30018/o-n-dynamic-solution-with-o-1-memory

 

    此问题还有一个变种:House Robber II ,这种情况下,n个房子是连成环的。直接给答案了:

int rob(vector<int>& nums) {
    int n = nums.size();
    if (n == 0)
        return 0;
    if (n == 1)
        return nums[0];
    if (n == 2)
        return max(nums[0], nums[1]);
    // rob 1 to n-1
    int a = nums[0];
    int b = 0;
    for (int i = 1; i < n-1; ++i)
    {
        int tmp = max(a, b);
        a = b + nums[i];
        b = tmp;
    }
    int first = max(a, b);
    // rob 2 to n
    a = nums[1];
    b = 0;
    for (int i = 2; i < n; ++i)
    {
        int tmp = max(a, b);
        a = b + nums[i];
        b = tmp;
    }
    int second = max(a, b);

    return max(first, second);
    
}

 

posted @ 2015-08-24 16:27  Sawyer Ford  阅读(256)  评论(0编辑  收藏  举报